UNIXSocket - Crystal 1.20.0

# class UNIXSocket

- UNIXSocket
- Socket
- IO
- Reference
- Object

##
Overview

A local interprocess communication clientsocket.

Available on UNIX-like operating systems, and Windows 10 Build 17063 or above. Not all features are supported on Windows.

NOTE To use `UNIXSocket`, you must explicitly import it with `require "socket"`

Example usage:

    require "socket"

    sock = UNIXSocket.new("/tmp/myapp.sock")
    sock.puts "message"
    response = sock.gets
    sock.close

##
Direct Known Subclasses

- UNIXServer

##
Defined in:

socket/unix_socket.cr

##
Constructors

- .new(path : Path | String, type : Type = Type::STREAM)

  Connects a named UNIX socket, bound to a filesystem pathname.

- .new(*, fd : Handle, type : Type = Type::STREAM, path : Path | String | Nil = nil)

  Creates an UNIXSocket from an existing system file descriptor or socket handle.

##
Class Method Summary

- .open(path : Path | String, type : Type = Type::STREAM, &)

  Opens an UNIX socket to a filesystem pathname, yields it to the block, then eventually closes the socket when the block returns.

- .pair(type : Type = Type::STREAM) : Tuple(UNIXSocket, UNIXSocket)

  Returns a pair of unnamed UNIX sockets.

- .pair(type : Type = Type::STREAM, &)

  Creates a pair of unnamed UNIX sockets (see `.pair`) and yields them to the block.

##
Instance Method Summary

- #local_address : Socket::UNIXAddress
- #path : String | Nil
- #receive(max_message_size = 512) : Tuple(String, UNIXAddress)

  Receives a text message from the previously bound address.

- #remote_address : Socket::UNIXAddress

### Instance methods inherited from class `Socket`

accept : Socket accept, accept? : Socket | Nil accept?, bind(host : String, port : Int) : Nil
bind(port : Int)
bind(addr : Socket::Address) : Nil bind, blocking blocking, blocking=(value) blocking=, broadcast=(val : Bool) broadcast=, broadcast? : Bool broadcast?, close_on_exec=(arg : Bool) close_on_exec=, close_on_exec? close_on_exec?, close_read close_read, close_write close_write, closed? : Bool closed?, connect(host : String, port : Int, connect_timeout = nil) : Nil
connect(addr, timeout = nil) : Nil
connect(addr, timeout = nil, &) connect, family : Family family, fcntl(cmd, arg = 0) fcntl, fd fd, finalize finalize, inspect(io : IO) : Nil inspect, keepalive=(val : Bool) keepalive=, keepalive? keepalive?, linger linger, linger=(val : Int | Nil) linger=, listen(backlog : Int = SOMAXCONN) : Nil
listen(backlog : Int = SOMAXCONN, &) listen, protocol : Protocol protocol, read_timeout : Time::Span | Nil read_timeout, read_timeout=(read_timeout : Time::Span | Nil)
read_timeout=(read_timeout : Number) : Number read_timeout=, receive(message : Bytes) : Tuple(Int32, Address)
receive(max_message_size = 512) : Tuple(String, Address) receive, recv_buffer_size : Int32 recv_buffer_size, recv_buffer_size=(val : Int32) recv_buffer_size=, reuse_address=(val : Bool) reuse_address=, reuse_address? : Bool reuse_address?, reuse_port=(val : Bool) reuse_port=, reuse_port? : Bool reuse_port?, send(message, to addr : Address) : Int32
send(message) : Int32 send, send_buffer_size : Int32 send_buffer_size, send_buffer_size=(val : Int32) send_buffer_size=, tty? tty?, type : Type type, write_timeout : Time::Span | Nil write_timeout, write_timeout=(write_timeout : Time::Span | Nil)
write_timeout=(write_timeout : Number) : Number write_timeout=

### Constructor methods inherited from class `Socket`

new(family : Family, type : Type, protocol : Protocol = Protocol::IP, blocking = nil)
new(fd, family : Family, type : Type, protocol : Protocol = Protocol::IP, blocking = nil) new, tcp(family : Family, blocking = nil) : self tcp, udp(family : Family, blocking = nil) : self udp, unix(type : Type = Type::STREAM, blocking = nil) : self unix

### Class methods inherited from class `Socket`

fcntl(fd, cmd, arg = 0) fcntl, get_blocking(fd : Handle) : Bool get_blocking, ip?(string : String) ip?, set_blocking(fd : Handle, value : Bool) set_blocking

### Instance methods inherited from module `Crystal::System::Socket`

__evloop_data : EventLoop::Polling::Arena::Index __evloop_data, __evloop_data=(__evloop_data : EventLoop::Polling::Arena::Index) __evloop_data=, close_volatile_fd? : Int32 | Nil close_volatile_fd?, socket_close(&)
socket_close socket_close

### Class methods inherited from module `Crystal::System::Socket`

fcntl(fd, cmd, arg = 0) fcntl, get_blocking(fd : Handle) get_blocking, set_blocking(fd : Handle, value : Bool) set_blocking, socket(family, type, protocol, blocking) : Handle socket, socketpair(type : ::Socket::Type, protocol : ::Socket::Protocol, blocking : Bool) : Tuple(Handle, Handle) socketpair

### Instance methods inherited from module `IO::Buffered`

buffer_size : Int32 buffer_size, buffer_size=(value) buffer_size=, close : Nil close, flush : self flush, flush_on_newline=(flush_on_newline : Bool) : Bool flush_on_newline=, flush_on_newline? : Bool flush_on_newline?, peek : Bytes peek, pos : Int64 pos, read(slice : Bytes) : Int32 read, read_buffering=(read_buffering : Bool) : Bool read_buffering=, read_buffering? : Bool read_buffering?, rewind : self rewind, sync=(sync : Bool) : Bool sync=, sync? : Bool sync?, unbuffered_close unbuffered_close, unbuffered_flush unbuffered_flush, unbuffered_read(slice : Bytes) unbuffered_read, unbuffered_rewind unbuffered_rewind, unbuffered_write(slice : Bytes) unbuffered_write, write(slice : Bytes) : Nil write

### Instance methods inherited from class `IO`

<<(obj : _) : self <<, close close, closed? : Bool closed?, each_byte(&) : Nil
each_byte each_byte, each_char(&) : Nil
each_char each_char, each_line(*args, **options, &block : String -> ) : Nil
each_line(*args, **options) each_line, encoding : String encoding, flush flush, getb_to_end : Bytes getb_to_end, gets(delimiter : Char, limit : Int, chomp = false) : String | Nil
gets(chomp : Bool = true) : String | Nil
gets(limit : Int, chomp : Bool = false) : String | Nil
gets(delimiter : Char, chomp : Bool = false) : String | Nil
gets(delimiter : String, chomp = false) : String | Nil gets, gets_to_end : String gets_to_end, peek : Bytes | Nil peek, pos pos, pos=(value) pos=, print(obj : _) : Nil
print(*objects : _) : Nil print, printf(format_string : String, args : Array | Tuple) : Nil
printf(format_string : String, *args) : Nil printf, puts(string : String) : Nil
puts(obj : _) : Nil
puts : Nil
puts(*objects : _) : Nil puts, read(slice : Bytes) read, read_at(offset, bytesize, & : IO -> ) read_at, read_byte : UInt8 | Nil read_byte, read_bytes(type, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) read_bytes, read_char : Char | Nil read_char, read_fully(slice : Bytes) : Int32 read_fully, read_fully?(slice : Bytes) : Int32 | Nil read_fully?, read_greedy(slice : Bytes) : Int32 read_greedy, read_line(*args, **options) : String read_line, read_string(bytesize : Int) : String read_string, read_utf8(slice : Bytes) : Int32 read_utf8, read_utf8_byte : UInt8 | Nil read_utf8_byte, rewind rewind, seek(offset, whence : Seek = Seek::Set) seek, set_encoding(encoding : String, invalid : Symbol | Nil = nil) : Nil set_encoding, skip(bytes_count : Int) : Nil skip, skip_to_end : Nil skip_to_end, tell tell, tty? : Bool tty?, write(slice : Bytes) : Nil write, write_byte(byte : UInt8) : Nil write_byte, write_bytes(object : _, format : IO::ByteFormat = IO::ByteFormat::SystemEndian) : Nil write_bytes, write_string(slice : Bytes) : Nil write_string, write_utf8(slice : Bytes) : Nil write_utf8

### Class methods inherited from class `IO`

copy(src : IO, dst : IO, limit : Int) : Int64
copy(src : IO, dst : IO) : Int64 copy, pipe(read_blocking : Bool | Nil = nil, write_blocking : Bool | Nil = nil) : Tuple(IO::FileDescriptor, IO::FileDescriptor)
pipe(read_blocking = nil, write_blocking = nil, &) pipe, same_content?(stream1 : IO, stream2 : IO) : Bool same_content?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(path : Path | String, type : Type = Type::STREAM) #

Connects a named UNIX socket, bound to a filesystem pathname.

def self.new(*, fd : Handle, type : Type = Type::STREAM, path : Path | String | Nil = nil) #

Creates an UNIXSocket from an existing system file descriptor or socket handle.

This adopts the system socket into the IO system that will reconfigure it as per the event loop runtime requirements.

NOTE On Windows, the handle must have been created with `WSA_FLAG_OVERLAPPED`.

##
Class Method Detail

def self.open(path : Path | String, type : Type = Type::STREAM, &) #

Opens an UNIX socket to a filesystem pathname, yields it to the block, then eventually closes the socket when the block returns.

Returns the value of the block.

def self.pair(type : Type = Type::STREAM) : Tuple(UNIXSocket, UNIXSocket) #

Returns a pair of unnamed UNIX sockets.

Not supported on Windows.

    require "socket"

    left, right = UNIXSocket.pair

    spawn do
      # echo server
      message = right.gets
      right.puts message
    end

    left.puts "message"
    left.gets # => "message"

def self.pair(type : Type = Type::STREAM, &) #

Creates a pair of unnamed UNIX sockets (see `.pair`) and yields them to the block. Eventually closes both sockets when the block returns.

Returns the value of the block.

Not supported on Windows.

##
Instance Method Detail

def local_address : Socket::UNIXAddress #
def path : String | Nil #
def receive(max_message_size = 512) : Tuple(String, UNIXAddress) #
Description copied from class Socket

Receives a text message from the previously bound address.

    require "socket"

    server = Socket.udp(Socket::Family::INET)
    server.bind("localhost", 1234)

    message, client_addr = server.receive

def remote_address : Socket::UNIXAddress #